#include "stack.h"
#include <stdlib.h>
#include <stddef.h>
#include <assert.h>

#define MAXSTACKSIZE 32768

/* Stacks are *mutable*, as everything else would require to copy the 
   whole array (welcome to C). */

struct stack {
    int st[MAXSTACKSIZE];
    int st_ptr;
};

stack empty()
{
    stack s;
    if ((s= malloc(sizeof(struct stack)))== NULL) exit(-1); // Out of memory
    s-> st_ptr= 0;
    return s;
}

void push(stack s, int i)
{
   s->st[s->st_ptr++]= i;
}

int top(stack s) 
{
   assert(s-> st_ptr > 0 /* top of empty stack */);
   return s->st[s->st_ptr- 1];
}

void pop(stack s)
{
   assert(s-> st_ptr > 0 /* pop of empty stack */);
   s->st_ptr--;
}

int isEmpty(stack s)
{
    return s-> st_ptr == 0;
}